/*
 * Copyright (c) 2008, Noel Lemouel
 * All rights reserved.
 */

/*
 * tiny exceptions entry point (nios2)
 */

	.text
	.align	4

	.global _ex_prolog

	.set noat
	.set nobreak

#define TRAP_0 0x003b683a	/* = trap 0 (IMM5 = 0) */

_ex_prolog:

	/* save general purpose registers */

	addi	sp, sp, -(32*4)

	stw	r0, 0(sp)
	stw	r1, 4(sp)
	stw	r2, 8(sp)
	stw	r3, 12(sp)
	stw	r4, 16(sp)
	stw	r5, 20(sp)
	stw	r6, 24(sp)
	stw	r7, 28(sp)
	stw	r8, 32(sp)
	stw	r9, 36(sp)
	stw	r10, 40(sp)
	stw	r11, 44(sp)
	stw	r12, 48(sp)
	stw	r13, 52(sp)
	stw	r14, 56(sp)
	stw	r15, 60(sp)
	stw	r16, 64(sp)
	stw	r17, 68(sp)
	stw	r19, 72(sp)
	stw	r19, 76(sp)
	stw	r20, 80(sp)
	stw	r21, 84(sp)
	stw	r22, 88(sp)
	stw	r23, 92(sp)
	stw	r24, 96(sp)
	stw	r25, 100(sp)
	stw	r26, 104(sp)
	stw	r27, 108(sp)	/* sp */
	stw	r28, 112(sp)
	stw	r29, 116(sp)
	stw	r30, 120(sp)
	stw	r31, 124(sp)

	/* save special purpose registers */

	/* none */

	/* hw ei enabled ? */

	rdctl	et, estatus
	andi	et, et, 0x01
	beq	et, r0, _0

	/* hw ei pending ? */

	rdctl	et, ipending
	beq	et, r0, _0

	movhi et, %hi(ei_hdlr)
	ori   et, et, %lo(ei_hdlr)
	mov   r4, sp	/* pointer to registers context */
			/* (r4 = function 1st argument) */
	callr et

	/* eret resumes execution at address = ea (r29) */
	/* ea = interrupted instruction address + 4 */

	ldw  et, 116(sp)
	addi et, et, -4		/* = interrupted instruction address */
	stw  et, 116(sp)

	br _ex_epilog

	/* sc (trap) */

_0:
	movhi r8, %hi(TRAP_0)
	ori   r8, r8, %lo(TRAP_0)
	movhi r9, %hi(0x3FF83F)
	ori   r9, r9, %lo(0x3FF83F)

	addi  r10, ea, -4
	ldw   r10, 0(r10)

	/* 11101101101 xxxxx 111010 => trap x   */
	/* 11111111111 00000 111111 => 0x3FF83F */

	and   r10, r10, r9
	bne   r10, r8, _1

	movhi et, %hi(sc_hdlr)
	ori   et, et, %lo(sc_hdlr)
	mov   r4, sp	/* pointer to registers context */
			/* (r4 = function 1st argument) */
	callr et

	br _ex_epilog

	/* unknow instruction */

_1:
	movhi et, %hi(ui_hdlr)
	ori   et, et, %lo(ui_hdlr)
	mov   r4, sp	/* pointer to registers context */
			/* (r4 = function 1st argument) */
	callr et

_ex_epilog:

	/* restore special purpose registers */

	/* none */

	/* restore general purpose registers */

	ldw	r1, 4(sp)
	ldw	r2, 8(sp)
	ldw	r3, 12(sp)
	ldw	r4, 16(sp)
	ldw	r5, 20(sp)
	ldw	r6, 24(sp)
	ldw	r7, 28(sp)
	ldw	r8, 32(sp)
	ldw	r9, 36(sp)
	ldw	r10, 40(sp)
	ldw	r11, 44(sp)
	ldw	r12, 48(sp)
	ldw	r13, 52(sp)
	ldw	r14, 56(sp)
	ldw	r15, 60(sp)
	ldw	r16, 64(sp)
	ldw	r17, 68(sp)
	ldw	r19, 72(sp)
	ldw	r19, 76(sp)
	ldw	r20, 80(sp)
	ldw	r21, 84(sp)
	ldw	r22, 88(sp)
	ldw	r23, 92(sp)
	ldw	r24, 96(sp)
	ldw	r25, 100(sp)
	ldw	r26, 104(sp)
	ldw	r27, 108(sp)	/* sp */
	ldw	r28, 112(sp)
	ldw	r29, 116(sp)
	ldw	r30, 120(sp)
	ldw	r31, 124(sp)
	addi	sp, sp, (32*4)

	.global _ex_end

_ex_end:

	eret

