/*
 * Copyright (c) 2009, Noel Lemouel
 * All rights reserved. See LICENCE file for details.
 */

#ifndef __24CXX_H__
#define __24CXX_H__

#define MEM_24C21_ADDRESS 0xa0

#define MEM_24C21_SIZE 1024   /* 128*8 */

#define MEM_24C01_SIZE 1024   /* 128*8 */
#define MEM_24C02_SIZE 2048   /* 256*8 */
#define MEM_24C04_SIZE 4096   /* 512*8 */
#define MEM_24C08_SIZE 8192   /* 1024*8 */
#define MEM_24C16_SIZE 16384  /* 2048*8 */

#define MEM_24C01_PW_SIZE 0x08
#define MEM_24C02_PW_SIZE 0x08
#define MEM_24C04_PW_SIZE 0x0f
#define MEM_24C08_PW_SIZE 0x0f
#define MEM_24C16_PW_SIZE 0x0f

extern void mem_24c21_bidir_mode_en(void);

int mem_24cxx_random_read(unsigned char i2c_addr, unsigned int wrd_addr);
int mem_24cxx_byte_write(unsigned char val, unsigned char i2c_addr, unsigned int wrd_addr);
int mem_24cxx_sequential_read(unsigned char* buf, unsigned char i2c_addr, unsigned int offset, size_t length);
int mem_24cxx_page_write(unsigned char* buf, unsigned char i2c_addr, unsigned int offset, size_t length);

#endif /* __24CXX_H__ */

