/*
 * Copyright (c) 2009, Noel Lemouel
 * All rights reserved. See LICENCE file for details.
 */

#ifndef __FB_H__
#define __FB_H__

typedef volatile struct lcd_ctrl_s {
   unsigned int status; /* read only */
   unsigned int ctrl;   /* r/w */
   unsigned int l0_dma_start;
   unsigned int l0_dma_len;
} lcd_ctrl_t;

#define LCD_IVS  0x0001
#define LCD_IEN  0x0001
#define LCD_DMA0 0x0002
#define LCD_L0   0x0004

extern void fb_vsync(void);
extern void fb_dma0_en(void);
extern void fb_dma0_di(void);
extern void fb_l0_en(void);
extern void fb_l0_di(void);
extern void fb_l0_remap_buffer(unsigned short* fb_base);
extern int fb_init(unsigned short* fb_base);

#endif /* __FB_H__ */

