/*
 * Copyright (c) 2007, Noel Lemouel
 * All rights reserved. See LICENCE file for details.
 */

#ifndef __FLASH_H__
#define __FLASH_H__

#define BYTE_MODE   0
#define WORD_MODE   1

#include <types.h>

typedef struct s29gl_flash_profile {
    u16 manufacturer_ID;
    u16 device_ID;
    u32 base_address;
    /* u32 nbyte_mode; */   /* byte(0) or word(1) mode */
    u32 device_size;        /* Mbits */
    u32 sector_size;        /* kbytes */
    u32 sector_count;
}s29gl_flash_profile_t;

typedef struct s29gl_flash_cmd {
    volatile u16 *addr0;
    volatile u16 *addr1;
    volatile u16 *cfi_addr;
    volatile u16 *device_ID_x01;
    volatile u16 *device_ID_x0e;
    volatile u16 *device_ID_x0f;   
    volatile u16 *manufacturer_ID;
    volatile u16 *sector_base;
    volatile u16 *word_address;
}s29gl_flash_cmd_t;

/* function prototypes */

s32 s29gl_init(u32 flash_base);
s32 s29gl_erase_all(void);
s32 s29gl_sector_erase(u32 sector_base);

s32 s29gl_byte_write(u32 flash_base, u32 word_address, u16 data);
s32 s29gl_buffer_write(u32 flash_base, u32 offset, u16* buf, u32 len);
void s29gl_reset(u32 flash_base);

#endif /* __FLASH_H__ */

