/*
 * Copyright (c) 2008, Noel Lemouel
 * All rights reserved. See LICENCE file for details.
 */

#ifndef __NIOS2_H_
#define __NIOS2_H_

/* general purpose registers */

#define nios2_rd(reg)\
   ({ unsigned int val;\
      __asm__ __volatile__ ( "mov %0, " #reg \
                             : "=r" (val) ); \
    val;})

#define nios2_wr(reg, val)\
   ({ __asm__ __volatile__ ( "mov " #reg ", %0" \
                             : /* no output */ \
                             : "r" (val) \
                           ); \
   })

/* control registers */

#define nios2_rdctl(ctlN)\
   ({ unsigned int val;\
      __asm__ __volatile__ ( "rdctl %0, " #ctlN \
                             : "=r" (val) ); \
    val;})

#define nios2_wrctl(ctlN, val)\
   ({ __asm__ __volatile__ ( "wrctl " #ctlN ", %0" \
                             : /* no output */ \
                             : "r" (val) \
                           ); \
   })

#define NIOS2_CTL_STATUS_PIE   0x01
#define NIOS2_CTL_ESTATUS_EPIE 0x01

/* utility */

#define sym_rd(sym)\
   ({ unsigned int val;\
   __asm__ __volatile__ ( "stwio r4, -4(sp)\n\t" \
                          "movhi r4, %hi(" #sym ")\n\t" \
                          "ori r4, r4, %lo(" #sym ")\n\r" \
                          "mov %0, r4\n\t" \
                          "ldwio r4, -4(sp)" \
                          : "=r" (val) \
                        ); \
    val;})

struct pt_regs {
   unsigned int reg[32];
};

#endif /* __NIOS2_H_ */

