/*
 * Copyright (c) 2010, Noel Lemouel
 * All rights reserved. See LICENCE file for details.
 */

#ifndef __DRAW_H__
#define __DRAW_H__

#include <types.h>

typedef struct fb_s{
	u16 w;
	u16 h;
	u16 bpp;
	u8 *base;
} fb_t;

typedef struct area_s{
	u16 x;
	u16 y;
	u16 w;
	u16 h;
} area_t;

typedef struct pixel_s{
	u8 r;
	u8 g;
	u8 b;
	u8 a;
} pixel_t;

/* 16bits linear framebuffer operations */
extern s32 area_fill_16(fb_t* fb, u16 color, area_t* area);
extern u16 rgb24_to_16(u8 r, u8 g, u8 b);

#endif /* __DRAW_H__ */
