/*
 * (C) Copyright 2008
 * Noel Lemouel <noel@stellae.fr>
 */

#ifndef __TGA_H__
#define __TGA_H__

#include <types.h>
#include "sprite.h"

enum {
	TGA_TYPE_NO_DATA = 0,
	TGA_TYPE_COLOR_MAP,
	TGA_TYPE_TRUE_COLOR,
	TGA_TYPE_BW,
	TGA_TYPE_RLE_COLOR_MAP = 9,
	TGA_TYPE_RLE_TRUE_COLOR,
	TGA_TYPE_RLE_BW,
};

struct tga_header{
	u8 id_len;
	u8 color_map_type;
	u8 img_type;
	u8 color_map_spec[5];
	u8 img_spec[10];
} __attribute__((packed));

struct tga_img_spec{
	u8 x_origin[2];
	u8 y_origin[2];
	u8 w[2];
	u8 h[2];
	u8 bpp;
	u8 a;
} __attribute__((packed));

typedef struct tga_info_s{
	u8* base;
	u16 w;
	u16 h;
	u8 type;
} tga_info_t;

extern s32 tga_info(u8* tga_img, tga_info_t* tga_info);
extern void tga24_to_sprite16(tga_info_t* tga_24, sprite_t* sprite_16);

#endif /* __TGA_H__ */
