/*
 * Copyright (c) 2010, Noel Lemouel
 * All rights reserved. See LICENCE file for details.
 */

#include "math.h"

/* power pow(base, exponent) */
float pow(float b, unsigned int e)
{
   float p;

   if(!e) return 1;
   p = b * pow(b, e-1);
   return p;
}

/* factorial */
unsigned int fct(unsigned int n)
{
   unsigned int f;

   if(!n) return 1;
   f = n * fct(n-1);
   return f;
}

float deg(float rad)
{
   return (rad*180/M_PI);
}

float rad(float deg)
{
   return (deg*M_PI/180);
}

/* cosine: uses Taylor series */
/* returns the cosine of x in radians */
float cos(float x)
{
   unsigned int e;
   float i = 0;

   for(e=0; e<5; e++)
   {
      i += ((pow(x, e<<1) / (float)fct(e<<1)) * pow(-1.0, e));
   }

   return i;
}

/* sine: uses Taylor series */
/* returns the sine of x in radians */
float sin(float x)
{
   unsigned int e;
   float i = 0;

   for(e=0; e<5; e++)
   {
      i += ((pow(x, (e<<1)+1)) / (float)fct((e<<1)+1) * pow(-1.0, e));
   }

   return i;
}

